C This subroutine was prepared by S. Shafer, C. Hu, and J.W. Mandema
C for NONMEM use with 3-compartment models parameterized in volumes
C and clearances using multiple or single infusions as input.
C The input parameters RATE and AMT are the same
C as used in the PREDPP structure.
C Before using this routine make sure
C that the RATE, TIME, and AMT labels are in the proper DATRECS
C       V1 = parameter(1)
C       V2 = parameter(2)
C       V3 = parameter(3)
C       CL1 = parameter(4)
C       CL2 = parameter(5)
C       CL3 = parameter(6)
      SUBROUTINE PRED (ICALL,NEWIND,THETA,DATREC,INDXS,F,G,H)
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL DATREC
      SAVE
      INTEGER ICALL,NEWIND,INDXS
      LOGICAL CHKVAL
      DIMENSION THETA(*),DATREC(*),INDXS(*),G(10,*),H(10,*)
      DIMENSION ETA(10),EPS(10)
      COMMON/NMPRD1/IERPRD,NETEXT
      COMMON/NMPRD2/ETEXT(3)
      COMMON/NMPRD4/V1,V2,V3,CL1,CL2,CL3,TY
      DIMENSION COM(400)
      EQUIVALENCE (V1,COM(1))
      INTEGER IERPRD,NETEXT
      CHARACTER*132 ETEXT
      COMMON/ROCM12/MSEC
      INTEGER MSEC,I,J
      COMMON/VCL1/RATE,TOF,TON,
     $  L1,DL1E1,DL1E2,DL1E3,DL1E4,DL1E5,DL1E6,
     $  L2,DL2E1,DL2E2,DL2E3,DL2E4,DL2E5,DL2E6,
     $  L3,DL3E1,DL3E2,DL3E3,DL3E4,DL3E5,DL3E6,
     $  C1,DC1E1,DC1E2,DC1E3,DC1E4,DC1E5,DC1E6,
     $  C2,DC2E1,DC2E2,DC2E3,DC2E4,DC2E5,DC2E6,
     $  C3,DC3E1,DC3E2,DC3E3,DC3E4,DC3E5,DC3E6,
     $  S1P,DS1PE1,DS1PE2,DS1PE3,DS1PE4,DS1PE5,DS1PE6,
     $  S2P,DS2PE1,DS2PE2,DS2PE3,DS2PE4,DS2PE5,DS2PE6,
     $  S3P,DS3PE1,DS3PE2,DS3PE3,DS3PE4,DS3PE5,DS3PE6
C BEGIN ROUTINE HERE
C============================================================================
C First Pass Initialization
C============================================================================
C Get ETA,EPS if needed
      IF (ICALL.EQ.4) THEN
          IF (NEWIND.NE.2) CALL SIMETA(ETA)
          CALL SIMEPS(EPS)
          ETA(7) = 0.D0
      ELSE
          IF (NEWIND.NE.2) THEN
              CALL GETETA(ETA)
              EPS(01) = 0.D0
              ETA(7) = 0.D0
          ENDIF
      ENDIF
C===========================================================================
C change to the correct datrec
      TIME=DATREC(03)
C============================================================================
C Initialize state variables, exponentials, coefficients and partials,
C if new individual.  This if statement is terminated just prior to the
C double equal bars.
      IF (NEWIND.NE.2) THEN
         
         V1TV=THETA(1)
C Age        

         V1TV=V1TV-THETA(7)*(DATREC(8)-40)
C LBM

         V1TV=V1TV+THETA(12)*(DATREC(13)-55)

         E1=ETA(1)
        


         V1=V1TV*DEXP(E1)
         IF (V1.LE.0) THEN
             WRITE(*,*)'V1=0'
             WRITE(6,*)'V1=0'
             IERPRD=1
             RETURN
         ENDIF
         
         
         
         V2TV=THETA(2)
C Age         
         V2TV=V2TV-THETA(8)*(DATREC(8)-40)
C LBM         
         V2TV=V2TV+THETA(13)*(DATREC(13)-55)

         
         
         
         
         
         
         E2=ETA(2)
         V2=V2TV*DEXP(E2)
         IF (V2.LE.0) THEN
             WRITE(*,*)'V2=0'
             WRITE(6,*)'V2=0'
             IERPRD=1
             RETURN
         ENDIF
         
         
         
         V3TV=THETA(3)
C Age, not add to model        
C         V3TV=V3TV+THETA(9)*(DATREC(8)-40)
         
         
         
         
         
         
         
         
         E3=ETA(3)
         V3=V3TV*DEXP(E3)
         IF (V3.LE.0) THEN
             WRITE(*,*)'V3=0'
             WRITE(6,*)'V3=0'
             IERPRD=1
             RETURN
         ENDIF
         
         
         CL1TV=THETA(4)
C Age         
         CL1TV=CL1TV-THETA(9)*(DATREC(8)-40)
C LBM         
         CL1TV=CL1TV+THETA(14)*(DATREC(13)-55)
         
         
         
         
         
         
         
         
         
         
         
         E4=ETA(4)
         CL1=CL1TV*DEXP(E4)
         IF (CL1.LE.0) THEN
             WRITE(*,*)'CL1=0'
             WRITE(6,*)'CL1=0'
             IERPRD=1
             RETURN
         ENDIF
         
         
         CL2TV=THETA(5)
C Age         
         CL2TV=CL2TV-THETA(10)*(DATREC(8)-40)
         
C LBM No improvement in model         
C        CL2TV=CL2TV+THETA(16)*(DATREC(13)-55)
         
         
         
         
         
         E5=ETA(5)
         CL2=CL2TV*DEXP(E5)
         IF (CL2.LE.0) THEN
             WRITE(*,*)'CL2=0'
             WRITE(6,*)'CL2=0'
             IERPRD=1
             RETURN
         ENDIF
         
         


         CL3TV=THETA(6)
C Age          
         CL3TV=CL3TV-THETA(11)*(DATREC(8)-40)
         
         
         E6=ETA(6)
         CL3=CL3TV*DEXP(E6)
         
         
         IF (CL3.LE.0) THEN
             WRITE(*,*)'CL3=0'
             WRITE(6,*)'CL3=0'
             IERPRD=1
             RETURN
         ENDIF
C=====================================================================
C Determine rate constants and partials
         DV1E1 = DEXP(E1)*V1TV
         DV1E2 = 0.0D0
         DV1E3 = 0.0D0
         DV1E4 = 0.0D0
         DV1E5 = 0.0D0
         DV1E6 = 0.0D0
         K10 = Cl1/V1
         DK10E1 = -(DEXP(-E1+E4)*CL1TV/V1TV)
         DK10E2 = 0.D0
         DK10E3 = 0.D0
         DK10E4 = DEXP(-E1+E4)*CL1TV/V1TV
         DK10E5 = 0.D0
         DK10E6 = 0.D0
             K12 = Cl2/V1
             DK12E1 = -(DEXP(-E1+E5)*CL2TV/V1TV)
             DK12E2 = 0.D0
             DK12E3 = 0.D0
             DK12E4 = 0.D0
             DK12E5 = DEXP(-E1+E5)*CL2TV/V1TV
             DK12E6 = 0.D0
             K21 = Cl2/V2
             DK21E1 = 0.D0
             DK21E2 = -(DEXP(-E2+E5)*CL2TV/V2TV)
             DK21E3 = 0.D0
             DK21E4 = 0.D0
             DK21E5 = DEXP(-E2+E5)*CL2TV/V2TV
             DK21E6 = 0.D0
                 K13 = Cl3/V1
                 DK13E1 = -(DEXP(-E1+E6)*CL3TV/V1TV)
                 DK13E2 = 0.D0
                 DK13E3 = 0.D0
                 DK13E4 = 0.D0
                 DK13E5 = 0.D0
                 DK13E6 = DEXP(-E1+E6)*CL3TV/V1TV
                 K31 = Cl3/V3
                 DK31E1 = 0.D0
                 DK31E2 = 0.D0
                 DK31E3 = -(DEXP(-E3+E6)*CL3TV/V3TV)
                 DK31E4 = 0.D0
                 DK31E5 = 0.D0
                 DK31E6 = DEXP(-E3+E6)*CL3TV/V3TV
C============================================================================
C Determine exponents, coefficients, and partials
C In this section, indention is not used because the Fortran line
C length becomes too much of a hassle (aarghhh!)
C        Three compartment model.............................................
C        Uses method of solution to the cubic equation, complete with partials
         PI=DASIN(1.0D0)*2.0D0
         A0 = K10*K21*K31
         DA0E1=K21*K31*DK10E1+K10*K31*DK21E1+K10*K21*DK31E1
         DA0E2=K21*K31*DK10E2+K10*K31*DK21E2+K10*K21*DK31E2
         DA0E3=K21*K31*DK10E3+K10*K31*DK21E3+K10*K21*DK31E3
         DA0E4=K21*K31*DK10E4+K10*K31*DK21E4+K10*K21*DK31E4
         DA0E5=K21*K31*DK10E5+K10*K31*DK21E5+K10*K21*DK31E5
         DA0E6=K21*K31*DK10E6+K10*K31*DK21E6+K10*K21*DK31E6
         A1 = K10*K31+K21*K31+K21*K13+K10*K21+K31*K12
         DA1E1=K21*DK10E1+K31*DK10E1+K31*DK12E1+K21*DK13E1+K10*DK21E1+
     $         K13*DK21E1+K31*DK21E1+K10*DK31E1+K12*DK31E1+K21*DK31E1
         DA1E2=K21*DK10E2+K31*DK10E2+K31*DK12E2+K21*DK13E2+K10*DK21E2+
     $         K13*DK21E2+K31*DK21E2+K10*DK31E2+K12*DK31E2+K21*DK31E2
         DA1E3=K21*DK10E3+K31*DK10E3+K31*DK12E3+K21*DK13E3+K10*DK21E3+
     $         K13*DK21E3+K31*DK21E3+K10*DK31E3+K12*DK31E3+K21*DK31E3
         DA1E4=K21*DK10E4+K31*DK10E4+K31*DK12E4+K21*DK13E4+K10*DK21E4+
     $         K13*DK21E4+K31*DK21E4+K10*DK31E4+K12*DK31E4+K21*DK31E4
         DA1E5=K21*DK10E5+K31*DK10E5+K31*DK12E5+K21*DK13E5+K10*DK21E5+
     $         K13*DK21E5+K31*DK21E5+K10*DK31E5+K12*DK31E5+K21*DK31E5
         DA1E6=K21*DK10E6+K31*DK10E6+K31*DK12E6+K21*DK13E6+K10*DK21E6+
     $         K13*DK21E6+K31*DK21E6+K10*DK31E6+K12*DK31E6+K21*DK31E6
         A2 = K10+K12+K13+K21+K31
         DA2E1 = DK10E1+DK12E1+DK13E1+DK21E1+DK31E1
         DA2E2 = DK10E2+DK12E2+DK13E2+DK21E2+DK31E2
         DA2E3 = DK10E3+DK12E3+DK13E3+DK21E3+DK31E3
         DA2E4 = DK10E4+DK12E4+DK13E4+DK21E4+DK31E4
         DA2E5 = DK10E5+DK12E5+DK13E5+DK21E5+DK31E5
         DA2E6 = DK10E6+DK12E6+DK13E6+DK21E6+DK31E6
         P = A1-(A2*A2/3.0D0)
         DPE1=DA1E1 - 2.0D0*A2*DA2E1/3.0D0
         DPE2=DA1E2 - 2.0D0*A2*DA2E2/3.0D0
         DPE3=DA1E3 - 2.0D0*A2*DA2E3/3.0D0
         DPE4=DA1E4 - 2.0D0*A2*DA2E4/3.0D0
         DPE5=DA1E5 - 2.0D0*A2*DA2E5/3.0D0
         DPE6=DA1E6 - 2.0D0*A2*DA2E6/3.0D0
         Q = (2.0D0*A2*A2*A2/27.0D0)-(A1*A2/3.0D0)+A0
         DQE1=DA0E1-(1.0D0/3.0D0)*A2*DA1E1-(1.0D0/3.0D0)*
     $        A1*DA2E1+(2.0D0/9.0D0)*(A2*A2)*DA2E1
         DQE2=DA0E2-(1.0D0/3.0D0)*A2*DA1E2-(1.0D0/3.0D0)*
     $        A1*DA2E2+(2.0D0/9.0D0)*(A2*A2)*DA2E2
         DQE3=DA0E3-(1.0D0/3.0D0)*A2*DA1E3-(1.0D0/3.0D0)*
     $        A1*DA2E3+(2.0D0/9.0D0)*(A2*A2)*DA2E3
         DQE4=DA0E4-(1.0D0/3.0D0)*A2*DA1E4-(1.0D0/3.0D0)*
     $        A1*DA2E4+(2.0D0/9.0D0)*(A2*A2)*DA2E4
         DQE5=DA0E5-(1.0D0/3.0D0)*A2*DA1E5-(1.0D0/3.0D0)*
     $        A1*DA2E5+(2.0D0/9.0D0)*(A2*A2)*DA2E5
         DQE6=DA0E6-(1.0D0/3.0D0)*A2*DA1E6-(1.0D0/3.0D0)*
     $        A1*DA2E6+(2.0D0/9.0D0)*(A2*A2)*DA2E6
         R1 = DSQRT(-(P*P*P)/27.0D0)
         DR1E1=-(0.5D0/9.0D0)*P*P*DPE1/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         DR1E2=-(0.5D0/9.0D0)*P*P*DPE2/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         DR1E3=-(0.5D0/9.0D0)*P*P*DPE3/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         DR1E4=-(0.5D0/9.0D0)*P*P*DPE4/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         DR1E5=-(0.5D0/9.0D0)*P*P*DPE5/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         DR1E6=-(0.5D0/9.0D0)*P*P*DPE6/DSQRT(-(37.0D0/999.0D0)*P*P*P)
         R2 = (-Q/2.0D0)/R1
         DR2E1=-0.5D0*DQE1/R1 + 0.5D0*Q*DR1E1/(R1*R1)
         DR2E2=-0.5D0*DQE2/R1 + 0.5D0*Q*DR1E2/(R1*R1)
         DR2E3=-0.5D0*DQE3/R1 + 0.5D0*Q*DR1E3/(R1*R1)
         DR2E4=-0.5D0*DQE4/R1 + 0.5D0*Q*DR1E4/(R1*R1)
         DR2E5=-0.5D0*DQE5/R1 + 0.5D0*Q*DR1E5/(R1*R1)
         DR2E6=-0.5D0*DQE6/R1 + 0.5D0*Q*DR1E6/(R1*R1)
         IF (R2.LT.-1.0D0.OR.R2.GT.1.0D0) THEN
               WRITE(*,*) 'Illegal acos found'
               IERPRD=1
               RETURN
         ENDIF
         R3 = DACOS(R2)/3.0D0
         DR3E1=-(1.0D0/3.0D0)*DR2E1/DSQRT(1.0D0-R2*R2)
         DR3E2=-(1.0D0/3.0D0)*DR2E2/DSQRT(1.0D0-R2*R2)
         DR3E3=-(1.0D0/3.0D0)*DR2E3/DSQRT(1.0D0-R2*R2)
         DR3E4=-(1.0D0/3.0D0)*DR2E4/DSQRT(1.0D0-R2*R2)
         DR3E5=-(1.0D0/3.0D0)*DR2E5/DSQRT(1.0D0-R2*R2)
         DR3E6=-(1.0D0/3.0D0)*DR2E6/DSQRT(1.0D0-R2*R2)
         R4 = 2.0D0*DEXP(DLOG(R1)/3.0D0)
         DR4E1=(2.0D0/3.0D0)*DR1E1/(R1**(2.0D0/3.0D0))
         DR4E2=(2.0D0/3.0D0)*DR1E2/(R1**(2.0D0/3.0D0))
         DR4E3=(2.0D0/3.0D0)*DR1E3/(R1**(2.0D0/3.0D0))
         DR4E4=(2.0D0/3.0D0)*DR1E4/(R1**(2.0D0/3.0D0))
         DR4E5=(2.0D0/3.0D0)*DR1E5/(R1**(2.0D0/3.0D0))
         DR4E6=(2.0D0/3.0D0)*DR1E6/(R1**(2.0D0/3.0D0))
         L1 = -(DCOS(R3)*R4-A2/3.0D0)
         DL1E1=(1.0D0/3.0D0)*DA2E1-DCOS(R3)*DR4E1+R4*DR3E1*DSIN(R3)
         DL1E2=(1.0D0/3.0D0)*DA2E2-DCOS(R3)*DR4E2+R4*DR3E2*DSIN(R3)
         DL1E3=(1.0D0/3.0D0)*DA2E3-DCOS(R3)*DR4E3+R4*DR3E3*DSIN(R3)
         DL1E4=(1.0D0/3.0D0)*DA2E4-DCOS(R3)*DR4E4+R4*DR3E4*DSIN(R3)
         DL1E5=(1.0D0/3.0D0)*DA2E5-DCOS(R3)*DR4E5+R4*DR3E5*DSIN(R3)
         DL1E6=(1.0D0/3.0D0)*DA2E6-DCOS(R3)*DR4E6+R4*DR3E6*DSIN(R3)
         L2 = -(DCOS(R3+2.0D0*PI/3.0D0)*R4-A2/3.0D0)
         DL2E1=(1.0D0/3.0D0)*DA2E1-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E1+R4*DR3E1*DSIN(2.0D0*PI/3.0D0+R3)
         DL2E2=(1.0D0/3.0D0)*DA2E2-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E2+R4*DR3E2*DSIN(2.0D0*PI/3.0D0+R3)
         DL2E3=(1.0D0/3.0D0)*DA2E3-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E3+R4*DR3E3*DSIN(2.0D0*PI/3.0D0+R3)
         DL2E4=(1.0D0/3.0D0)*DA2E4-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E4+R4*DR3E4*DSIN(2.0D0*PI/3.0D0+R3)
         DL2E5=(1.0D0/3.0D0)*DA2E5-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E5+R4*DR3E5*DSIN(2.0D0*PI/3.0D0+R3)
         DL2E6=(1.0D0/3.0D0)*DA2E6-DCOS(2.0D0*PI/3.0D0+R3)
     $         *DR4E6+R4*DR3E6*DSIN(2.0D0*PI/3.0D0+R3)
         L3 = -(DCOS(R3+4.0D0*PI/3.0D0)*R4-A2/3.0D0)
         DL3E1=(1.0D0/3.0D0)*DA2E1-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E1+R4*DR3E1*DSIN(4.0D0*PI/3.0D0+R3)
         DL3E2=(1.0D0/3.0D0)*DA2E2-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E2+R4*DR3E2*DSIN(4.0D0*PI/3.0D0+R3)
         DL3E3=(1.0D0/3.0D0)*DA2E3-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E3+R4*DR3E3*DSIN(4.0D0*PI/3.0D0+R3)
         DL3E4=(1.0D0/3.0D0)*DA2E4-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E4+R4*DR3E4*DSIN(4.0D0*PI/3.0D0+R3)
         DL3E5=(1.0D0/3.0D0)*DA2E5-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E5+R4*DR3E5*DSIN(4.0D0*PI/3.0D0+R3)
         DL3E6=(1.0D0/3.0D0)*DA2E6-DCOS(4.0D0*PI/3.0D0+R3)
     $         *DR4E6+R4*DR3E6*DSIN(4.0D0*PI/3.0D0+R3)
C        Check for illegal values that will cause division by 0 or an overflow
         IF (CHKVAL(K21,L1).OR.CHKVAL(K31,L1).OR.
     $       CHKVAL(K21,L2).OR.CHKVAL(K31,L2).OR.
     $       CHKVAL(K21,L3).OR.CHKVAL(K31,L3).OR.
     $       CHKVAL(L1,L2).OR.CHKVAL(L1,L3).OR.CHKVAL(L2,L3)) THEN
                WRITE(*,*) 'Small denominator found'
                IERPRD=1
                RETURN
         ENDIF
         C1 = 1.0D0/V1*(K21-L1)*(K31-L1)/(L1-L2)/(L1-L3)
         DC1E1 = (K31-L1)*(DK21E1-DL1E1)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E1-DL1E1)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E1-DL2E1)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E1-DL3E1)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E1/((L1-L2)*(L1-L3)*V1*V1)
         DC1E2 = (K31-L1)*(DK21E2-DL1E2)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E2-DL1E2)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E2-DL2E2)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E2-DL3E2)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E2/((L1-L2)*(L1-L3)*V1*V1)
         DC1E3 = (K31-L1)*(DK21E3-DL1E3)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E3-DL1E3)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E3-DL2E3)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E3-DL3E3)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E3/((L1-L2)*(L1-L3)*V1*V1)
         DC1E4 = (K31-L1)*(DK21E4-DL1E4)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E4-DL1E4)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E4-DL2E4)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E4-DL3E4)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E4/((L1-L2)*(L1-L3)*V1*V1)
         DC1E5 = (K31-L1)*(DK21E5-DL1E5)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E5-DL1E5)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E5-DL2E5)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E5-DL3E5)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E5/((L1-L2)*(L1-L3)*V1*V1)
         DC1E6 = (K31-L1)*(DK21E6-DL1E6)/((L1-L2)*(L1-L3)*V1)
     $           +(K21-L1)*(DK31E6-DL1E6)/((L1-L2)*(L1-L3)*V1)
     $           -(K21-L1)*(K31-L1)*(DL1E6-DL2E6)/((L1-L2)
     $           *(L1-L2)*(L1-L3)*V1)-(K21-L1)*(K31-L1)
     $           *(DL1E6-DL3E6)/((L1-L2)*(L1-L3)*(L1-L3)*V1)
     $          -(K21-L1)*(K31-L1)*DV1E6/((L1-L2)*(L1-L3)*V1*V1)
         C2 = 1.0D0/V1*(K21-L2)*(K31-L2)/(L2-L1)/(L2-L3)
         DC2E1=(K31-L2)*(DK21E1-DL2E1)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E1-DL2E1)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E1-DL1E1)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E1-DL3E1)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E1/((L2-L1)*(L2-L3)*V1*V1)
         DC2E2=(K31-L2)*(DK21E2-DL2E2)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E2-DL2E2)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E2-DL1E2)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E2-DL3E2)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E2/((L2-L1)*(L2-L3)*V1*V1)
         DC2E3=(K31-L2)*(DK21E3-DL2E3)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E3-DL2E3)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E3-DL1E3)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E3-DL3E3)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E3/((L2-L1)*(L2-L3)*V1*V1)
         DC2E4=(K31-L2)*(DK21E4-DL2E4)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E4-DL2E4)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E4-DL1E4)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E4-DL3E4)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E4/((L2-L1)*(L2-L3)*V1*V1)
         DC2E5=(K31-L2)*(DK21E5-DL2E5)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E5-DL2E5)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E5-DL1E5)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E5-DL3E5)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E5/((L2-L1)*(L2-L3)*V1*V1)
         DC2E6=(K31-L2)*(DK21E6-DL2E6)/((L2-L1)*(L2-L3)*V1)
     $         +(K21-L2)*(DK31E6-DL2E6)/((L2-L1)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*(DL2E6-DL1E6)/((L2-L1)
     $         *(L2-L1)*(L2-L3)*V1)-(K21-L2)*(K31-L2)
     $         *(DL2E6-DL3E6)/((L2-L1)*(L2-L3)*(L2-L3)*V1)
     $         -(K21-L2)*(K31-L2)*DV1E6/((L2-L1)*(L2-L3)*V1*V1)
         C3 = 1.0D0/V1*(K21-L3)*(K31-L3)/(L3-L2)/(L3-L1)
         DC3E1=(K31-L3)*(DK21E1-DL3E1)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E1-DL3E1)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E1-DL1E1)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E1-DL2E1)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E1/((L3-L1)*(L3-L2)*V1*V1)
         DC3E2=(K31-L3)*(DK21E2-DL3E2)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E2-DL3E2)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E2-DL1E2)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E2-DL2E2)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E2/((L3-L1)*(L3-L2)*V1*V1)
         DC3E3=(K31-L3)*(DK21E3-DL3E3)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E3-DL3E3)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E3-DL1E3)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E3-DL2E3)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E3/((L3-L1)*(L3-L2)*V1*V1)
         DC3E4=(K31-L3)*(DK21E4-DL3E4)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E4-DL3E4)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E4-DL1E4)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E4-DL2E4)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E4/((L3-L1)*(L3-L2)*V1*V1)
         DC3E5=(K31-L3)*(DK21E5-DL3E5)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E5-DL3E5)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E5-DL1E5)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E5-DL2E5)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E5/((L3-L1)*(L3-L2)*V1*V1)
         DC3E6=(K31-L3)*(DK21E6-DL3E6)/((L3-L1)*(L3-L2)*V1)
     $         +(K21-L3)*(DK31E6-DL3E6)/((L3-L1)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*(DL3E6-DL1E6)/((L3-L1)
     $         *(L3-L1)*(L3-L2)*V1)-(K21-L3)*(K31-L3)
     $         *(DL3E6-DL2E6)/((L3-L1)*(L3-L2)*(L3-L2)*V1)
     $         -(K21-L3)*(K31-L3)*DV1E6/((L3-L1)*(L3-L2)*V1*V1)
C    End of three compartment model..........................................
C Initialize state variables, including partials=============================
         S1P = 0
         DS1PE1 = 0
         DS1PE2 = 0
         DS1PE3 = 0
         DS1PE4 = 0
         DS1PE5 = 0
         DS1PE6 = 0
         S2P = 0
         DS2PE1 = 0
         DS2PE2 = 0
         DS2PE3 = 0
         DS2PE4 = 0
         DS2PE5 = 0
         DS2PE6 = 0
         S3P = 0
         DS3PE1 = 0
         DS3PE2 = 0
         DS3PE3 = 0
         DS3PE4 = 0
         DS3PE5 = 0
         DS3PE6 = 0
         RATE = 0.D0
         TON  = 0.D0
         TOF  = 0.D0
      ENDIF
C============================================================================
C============================================================================
C Recursive (actually, reiterative) portion of calculation
C     First, process a partial infusion, if any
      IF (RATE.GT.0.D0.AND.TIME.GE.TOF) THEN
          DT  = TOF-TON
          LA1 = DEXP(-DT*L1)
          TR1 = RATE*C1*(1.0D0-LA1)/L1
          S1 = S1P*LA1+TR1
          DS1E1=(1.0D0-LA1)*RATE*DC1E1/L1-TR1*DL1E1/L1
     $          +C1*DT*RATE*DL1E1*LA1/L1
     $          -DT*S1P*DL1E1*LA1+DS1PE1*LA1
          DS1E2=(1.0D0-LA1)*RATE*DC1E2/L1-TR1*DL1E2/L1
     $          +C1*DT*RATE*DL1E2*LA1/L1
     $          -DT*S1P*DL1E2*LA1+DS1PE2*LA1
          DS1E3=(1.0D0-LA1)*RATE*DC1E3/L1-TR1*DL1E3/L1
     $          +C1*DT*RATE*DL1E3*LA1/L1
     $          -DT*S1P*DL1E3*LA1+DS1PE3*LA1
          DS1E4=(1.0D0-LA1)*RATE*DC1E4/L1-TR1*DL1E4/L1
     $          +C1*DT*RATE*DL1E4*LA1/L1
     $          -DT*S1P*DL1E4*LA1+DS1PE4*LA1
          DS1E5=(1.0D0-LA1)*RATE*DC1E5/L1-TR1*DL1E5/L1
     $          +C1*DT*RATE*DL1E5*LA1/L1
     $          -DT*S1P*DL1E5*LA1+DS1PE5*LA1
          DS1E6=(1.0D0-LA1)*RATE*DC1E6/L1-TR1*DL1E6/L1
     $          +C1*DT*RATE*DL1E6*LA1/L1
     $          -DT*S1P*DL1E6*LA1+DS1PE6*LA1
              LA2 = DEXP(-DT*L2)
              TR2 = RATE*C2*(1.0D0-LA2)/L2
              S2=S2P*LA2+TR2
          DS2E1=(1.0D0-LA2)*RATE*DC2E1/L2-TR2*DL2E1/L2
     $          +C2*DT*RATE*DL2E1*LA2/L2
     $          -DT*S2P*DL2E1*LA2+DS2PE1*LA2
          DS2E2=(1.0D0-LA2)*RATE*DC2E2/L2-TR2*DL2E2/L2
     $          +C2*DT*RATE*DL2E2*LA2/L2
     $          -DT*S2P*DL2E2*LA2+DS2PE2*LA2
          DS2E3=(1.0D0-LA2)*RATE*DC2E3/L2-TR2*DL2E3/L2
     $          +C2*DT*RATE*DL2E3*LA2/L2
     $          -DT*S2P*DL2E3*LA2+DS2PE3*LA2
          DS2E4=(1.0D0-LA2)*RATE*DC2E4/L2-TR2*DL2E4/L2
     $          +C2*DT*RATE*DL2E4*LA2/L2
     $          -DT*S2P*DL2E4*LA2+DS2PE4*LA2
          DS2E5=(1.0D0-LA2)*RATE*DC2E5/L2-TR2*DL2E5/L2
     $          +C2*DT*RATE*DL2E5*LA2/L2
     $          -DT*S2P*DL2E5*LA2+DS2PE5*LA2
          DS2E6=(1.0D0-LA2)*RATE*DC2E6/L2-TR2*DL2E6/L2
     $          +C2*DT*RATE*DL2E6*LA2/L2
     $          -DT*S2P*DL2E6*LA2+DS2PE6*LA2
              LA3 = DEXP(-DT*L3)
              TR3 = RATE*C3*(1.0D0-LA3)/L3
              S3 = S3P*LA3+TR3
          DS3E1=(1.0D0-LA3)*RATE*DC3E1/L3-TR3*DL3E1/L3
     $          +C3*DT*RATE*DL3E1*LA3/L3
     $          -DT*S3P*DL3E1*LA3+DS3PE1*LA3
          DS3E2=(1.0D0-LA3)*RATE*DC3E2/L3-TR3*DL3E2/L3
     $          +C3*DT*RATE*DL3E2*LA3/L3
     $          -DT*S3P*DL3E2*LA3+DS3PE2*LA3
          DS3E3=(1.0D0-LA3)*RATE*DC3E3/L3-TR3*DL3E3/L3
     $          +C3*DT*RATE*DL3E3*LA3/L3
     $          -DT*S3P*DL3E3*LA3+DS3PE3*LA3
          DS3E4=(1.0D0-LA3)*RATE*DC3E4/L3-TR3*DL3E4/L3
     $          +C3*DT*RATE*DL3E4*LA3/L3
     $          -DT*S3P*DL3E4*LA3+DS3PE4*LA3
          DS3E5=(1.0D0-LA3)*RATE*DC3E5/L3-TR3*DL3E5/L3
     $          +C3*DT*RATE*DL3E5*LA3/L3
     $          -DT*S3P*DL3E5*LA3+DS3PE5*LA3
          DS3E6=(1.0D0-LA3)*RATE*DC3E6/L3-TR3*DL3E6/L3
     $          +C3*DT*RATE*DL3E6*LA3/L3
     $          -DT*S3P*DL3E6*LA3+DS3PE6*LA3
          S1P = S1
          DS1PE1 = DS1E1
          DS1PE2 = DS1E2
          DS1PE3 = DS1E3
          DS1PE4 = DS1E4
          DS1PE5 = DS1E5
          DS1PE6 = DS1E6
          S2P = S2
          DS2PE1 = DS2E1
          DS2PE2 = DS2E2
          DS2PE3 = DS2E3
          DS2PE4 = DS2E4
          DS2PE5 = DS2E5
          DS2PE6 = DS2E6
          S3P = S3
          DS3PE1 = DS3E1
          DS3PE2 = DS3E2
          DS3PE3 = DS3E3
          DS3PE4 = DS3E4
          DS3PE5 = DS3E5
          DS3PE6 = DS3E6
          TON  = TOF
          TOF  = 0
          RATE = 0
      ENDIF
C     Now, bring the model forward to the current time
      DT  = TIME-TON
      LA1 = DEXP(-DT*L1)
      TR1 = RATE*C1*(1.0D0-LA1)/L1
      S1 = S1P*LA1+TR1
      DS1E1=(1.0D0-LA1)*RATE*DC1E1/L1-TR1*DL1E1/L1
     $      +C1*DT*RATE*DL1E1*LA1/L1
     $      -DT*S1P*DL1E1*LA1+DS1PE1*LA1
      DS1E2=(1.0D0-LA1)*RATE*DC1E2/L1-TR1*DL1E2/L1
     $      +C1*DT*RATE*DL1E2*LA1/L1
     $      -DT*S1P*DL1E2*LA1+DS1PE2*LA1
      DS1E3=(1.0D0-LA1)*RATE*DC1E3/L1-TR1*DL1E3/L1
     $      +C1*DT*RATE*DL1E3*LA1/L1
     $      -DT*S1P*DL1E3*LA1+DS1PE3*LA1
      DS1E4=(1.0D0-LA1)*RATE*DC1E4/L1-TR1*DL1E4/L1
     $      +C1*DT*RATE*DL1E4*LA1/L1
     $      -DT*S1P*DL1E4*LA1+DS1PE4*LA1
      DS1E5=(1.0D0-LA1)*RATE*DC1E5/L1-TR1*DL1E5/L1
     $      +C1*DT*RATE*DL1E5*LA1/L1
     $      -DT*S1P*DL1E5*LA1+DS1PE5*LA1
      DS1E6=(1.0D0-LA1)*RATE*DC1E6/L1-TR1*DL1E6/L1
     $      +C1*DT*RATE*DL1E6*LA1/L1
     $      -DT*S1P*DL1E6*LA1+DS1PE6*LA1
          LA2 = DEXP(-DT*L2)
          TR2 = RATE*C2*(1.0D0-LA2)/L2
          S2=S2P*LA2+TR2
      DS2E1=(1.0D0-LA2)*RATE*DC2E1/L2-TR2*DL2E1/L2
     $      +C2*DT*RATE*DL2E1*LA2/L2
     $      -DT*S2P*DL2E1*LA2+DS2PE1*LA2
      DS2E2=(1.0D0-LA2)*RATE*DC2E2/L2-TR2*DL2E2/L2
     $      +C2*DT*RATE*DL2E2*LA2/L2
     $      -DT*S2P*DL2E2*LA2+DS2PE2*LA2
      DS2E3=(1.0D0-LA2)*RATE*DC2E3/L2-TR2*DL2E3/L2
     $      +C2*DT*RATE*DL2E3*LA2/L2
     $      -DT*S2P*DL2E3*LA2+DS2PE3*LA2
      DS2E4=(1.0D0-LA2)*RATE*DC2E4/L2-TR2*DL2E4/L2
     $      +C2*DT*RATE*DL2E4*LA2/L2
     $      -DT*S2P*DL2E4*LA2+DS2PE4*LA2
      DS2E5=(1.0D0-LA2)*RATE*DC2E5/L2-TR2*DL2E5/L2
     $      +C2*DT*RATE*DL2E5*LA2/L2
     $      -DT*S2P*DL2E5*LA2+DS2PE5*LA2
      DS2E6=(1.0D0-LA2)*RATE*DC2E6/L2-TR2*DL2E6/L2
     $      +C2*DT*RATE*DL2E6*LA2/L2
     $      -DT*S2P*DL2E6*LA2+DS2PE6*LA2
              LA3 = DEXP(-DT*L3)
              TR3 = RATE*C3*(1.0D0-LA3)/L3
              S3 = S3P*LA3+TR3
      DS3E1=(1.0D0-LA3)*RATE*DC3E1/L3-TR3*DL3E1/L3
     $      +C3*DT*RATE*DL3E1*LA3/L3
     $      -DT*S3P*DL3E1*LA3+DS3PE1*LA3
      DS3E2=(1.0D0-LA3)*RATE*DC3E2/L3-TR3*DL3E2/L3
     $      +C3*DT*RATE*DL3E2*LA3/L3
     $      -DT*S3P*DL3E2*LA3+DS3PE2*LA3
      DS3E3=(1.0D0-LA3)*RATE*DC3E3/L3-TR3*DL3E3/L3
     $      +C3*DT*RATE*DL3E3*LA3/L3
     $      -DT*S3P*DL3E3*LA3+DS3PE3*LA3
      DS3E4=(1.0D0-LA3)*RATE*DC3E4/L3-TR3*DL3E4/L3
     $      +C3*DT*RATE*DL3E4*LA3/L3
     $      -DT*S3P*DL3E4*LA3+DS3PE4*LA3
      DS3E5=(1.0D0-LA3)*RATE*DC3E5/L3-TR3*DL3E5/L3
     $      +C3*DT*RATE*DL3E5*LA3/L3
     $      -DT*S3P*DL3E5*LA3+DS3PE5*LA3
      DS3E6=(1.0D0-LA3)*RATE*DC3E6/L3-TR3*DL3E6/L3
     $      +C3*DT*RATE*DL3E6*LA3/L3
     $      -DT*S3P*DL3E6*LA3+DS3PE6*LA3
      S1P = S1
      DS1PE1 = DS1E1
      DS1PE2 = DS1E2
      DS1PE3 = DS1E3
      DS1PE4 = DS1E4
      DS1PE5 = DS1E5
      DS1PE6 = DS1E6
      S2P = S2
      DS2PE1 = DS2E1
      DS2PE2 = DS2E2
      DS2PE3 = DS2E3
      DS2PE4 = DS2E4
      DS2PE5 = DS2E5
      DS2PE6 = DS2E6
      S3P = S3
      DS3PE1 = DS3E1
      DS3PE2 = DS3E2
      DS3PE3 = DS3E3
      DS3PE4 = DS3E4
      DS3PE5 = DS3E5
      DS3PE6 = DS3E6
C     Time on is reset to current time (iterative approach)
      TON=TIME
C     Set new rate, if any
C  do not forget to enter the correct datrec for amt and rate
      IF (DATREC(06).NE.0.D0) THEN
          RATE=DATREC(05)
          TOF=TIME+DATREC(06)/RATE
      ENDIF
      TY = S1+S2+S3
      TEPS=DEXP(EPS(01))
      Y=TY*TEPS
      H(1,1)=Y
C     Apply ETA, as indicated
          G(1,1)=TEPS*(DS1E1+DS2E1+DS3E1)
          H(1,2)=G(1,1)
          G(2,1)=TEPS*(DS1E2+DS2E2+DS3E2)
          H(1,3)=G(2,1)
          G(3,1)=TEPS*(DS1E3+DS2E3+DS3E3)
          H(1,4)=G(3,1)
          G(4,1)=TEPS*(DS1E4+DS2E4+DS3E4)
          H(1,5)=G(4,1)
          G(5,1)=TEPS*(DS1E5+DS2E5+DS3E5)
          H(1,6)=G(5,1)
          G(6,1)=TEPS*(DS1E6+DS2E6+DS3E6)
          H(1,7)=G(6,1)
      F=Y
      RETURN
      STOP
      END
C Check for division by almost 0
      LOGICAL FUNCTION CHKVAL (A,B)
      IMPLICIT DOUBLE PRECISION (A-Z)
      IF(DABS(A-B)/(A+B).GT.0.001D0) THEN
           CHKVAL = .FALSE.
      ELSE
           CHKVAL = .TRUE.
      ENDIF
      RETURN
      END
